require "import"
import "android.content.Intent"
import "android.net.Uri"
import "android.app.Activity"

-- Get the current activity context
local activity = activity or this

-- Define the Telegram channel link
local url = "https://t.me/technologyblindnepal"

-- Function to open the Telegram link
function openTelegramLink()
    -- Notify the user with sound and speech that the process is starting
    service.playSoundTick() -- Play a tick sound
    service.asyncSpeak("Opening the Telegram channel, Technology Blind Nepal. Please wait.")
    
    -- Create an intent for the Telegram application
    local intent = Intent(Intent.ACTION_VIEW)
    intent.setData(Uri.parse(url))
    intent.setPackage("org.telegram.messenger") -- Specify Telegram app package

    -- Check if the Telegram app is installed
    if intent.resolveActivity(activity.getPackageManager()) ~= nil then
        -- Open the link in the Telegram app
        activity.startActivity(intent)
        service.playSoundTick() -- Play a tick sound again
        service.asyncSpeak("The link was successfully opened in the Telegram application.")
    else
        -- If Telegram app is not installed, open the link in a browser
        service.playSoundTick() -- Play a tick sound
        service.asyncSpeak("Telegram application is not installed. Opening the link in a browser.")
        local browserIntent = Intent(Intent.ACTION_VIEW)
        browserIntent.setData(Uri.parse(url))
        activity.startActivity(browserIntent)
    end
end

-- Call the function to open the Telegram link
openTelegramLink()